import { ScalarsMap, NamingConvention, ConvertFn, ConvertOptions } from './types';
import { DeclarationBlockConfig } from './utils';
import { ASTNode } from 'graphql';
export interface BaseVisitorConvertOptions {
    useTypesPrefix?: boolean;
}
export interface ParsedConfig {
    scalars: ScalarsMap;
    convert: ConvertFn;
    typesPrefix: string;
}
export interface RawConfig {
    scalars?: ScalarsMap;
    namingConvention?: NamingConvention;
    typesPrefix?: string;
}
export declare class BaseVisitor<TRawConfig extends RawConfig = RawConfig, TPluginConfig extends ParsedConfig = ParsedConfig> {
    protected _parsedConfig: TPluginConfig;
    protected _declarationBlockConfig: DeclarationBlockConfig;
    constructor(rawConfig: TRawConfig, additionalConfig: TPluginConfig, defaultScalars?: ScalarsMap);
    readonly config: TPluginConfig;
    readonly scalars: ScalarsMap;
    protected convertName(node: ASTNode | string, options?: BaseVisitorConvertOptions & ConvertOptions): string;
}
