import * as autoBind from 'auto-bind';
import { DEFAULT_SCALARS } from './scalars';
import { convertFactory } from './naming';
export class BaseVisitor {
    constructor(rawConfig, additionalConfig, defaultScalars = DEFAULT_SCALARS) {
        this._declarationBlockConfig = {};
        this._parsedConfig = Object.assign({ scalars: Object.assign({}, (defaultScalars || DEFAULT_SCALARS), (rawConfig.scalars || {})), convert: convertFactory(rawConfig), typesPrefix: rawConfig.typesPrefix || '' }, (additionalConfig || {}));
        autoBind(this);
    }
    get config() {
        return this._parsedConfig;
    }
    get scalars() {
        return this.config.scalars;
    }
    convertName(node, options) {
        const useTypesPrefix = typeof (options && options.useTypesPrefix) === 'boolean' ? options.useTypesPrefix : true;
        return (useTypesPrefix ? this.config.typesPrefix : '') + this.config.convert(node, options);
    }
}
//# sourceMappingURL=base-visitor.js.map